'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

var Component = function Component(props) {
  var measuredParent = React.useCallback(function (node) {
    function ellipse(parentNode, childNode, txtNode) {
      var childWidth = childNode.offsetWidth,
          containerWidth = parentNode.offsetWidth;
      if (childWidth * 1.1 > containerWidth) {
        var str = txtNode.textContent,
            childChars = str.length,
            avgLetterSize = childWidth / childChars,
            canFit = containerWidth / avgLetterSize,
            delEachSide = (childChars - canFit + 5) / 2,
            endLeft = Math.floor(childChars / 2 - delEachSide),
            startRight = Math.ceil(childChars / 2 + delEachSide);
        txtNode.textContent = str.substr(0, endLeft) + "..." + str.substr(startRight);
      }
    }
    if (node !== null) {
      var parent = node.parentNode,
          child = parent.querySelector(".constrainedChild"),
          txtToEllipse = parent.querySelector(".constrainedEllipse");
      if (child !== null && txtToEllipse !== null) {
        ellipse(
        // Use the smaller width.
        node.offsetWidth > parent.offsetWidth ? parent : node, child, txtToEllipse);
      }
    }
  });
  return React__default.createElement(
    "div",
    { ref: measuredParent },
    props.children
  );
};

module.exports = Component;
//# sourceMappingURL=index.js.map
